"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.onExit = exports.onEntry = exports.reset = exports.stop = exports.start = void 0;
const randomException = () => {
    if (Math.random() > 0.5) {
        throw new Error('failure');
    }
};
const sleep = () => new Promise((resolve) => setTimeout(resolve, 1000));
const onStart = async () => {
    console.info('onStart');
    await sleep();
    randomException();
};
const onStop = async () => {
    console.info('onStop');
    await sleep();
    randomException();
};
const onEntry = async (context, event) => {
    console.info('onEntry', context.counter, event);
};
exports.onEntry = onEntry;
const onExit = async (context, event) => {
    console.info('onExit', context.counter, event);
};
exports.onExit = onExit;
const start = async () => {
    console.info('start()');
    await onStart();
};
exports.start = start;
const stop = async () => {
    console.info('stop()');
    await onStop();
};
exports.stop = stop;
const reset = async () => {
    console.info('reset()');
    await stop();
    await start();
};
exports.reset = reset;
//# sourceMappingURL=fixture.js.map