#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const tsd_1 = require("tsd");
const rxjs_1 = require("rxjs");
const state_switch_js_1 = require("../src/state-switch.js");
(0, tstest_1.test)('StateSwitch satisfy DOM EventTarget: HasEventTargetAddRemove', async (t) => {
    const state = new state_switch_js_1.StateSwitch();
    (0, tsd_1.expectAssignable)(state);
    t.pass('expectAssignable match listener argument typings');
});
(0, tstest_1.test)('RxJS: fromEvent type inference', async (t) => {
    const state = new state_switch_js_1.StateSwitch();
    const event$ = (0, rxjs_1.fromEvent)(state, 'on');
    (0, tsd_1.expectType)(event$);
    const future = (0, rxjs_1.firstValueFrom)(event$);
    state.on('pending');
    const result = await future;
    (0, tsd_1.expectType)(result);
});
(0, tstest_1.test)('RxJS: fromEvent stream for the second value', async (t) => {
    const state = new state_switch_js_1.StateSwitch();
    const event$ = (0, rxjs_1.fromEvent)(state, 'off');
    state.off('pending');
    const future = (0, rxjs_1.firstValueFrom)(event$);
    state.off(true);
    const result = await future;
    t.equal(result, true, 'should get "true" result');
});
//# sourceMappingURL=from-event-type.spec.js.map