import { StateSwitch } from './state-switch.js';
class BusyIndicator {
    constructor(...args) {
        this.state = new StateSwitch(...args);
    }
    busy(b) {
        if (typeof b === 'undefined') {
            return !!(this.state.on());
        }
        if (b) {
            this.state.on(true);
        }
        else {
            this.state.off(true);
        }
    }
    /**
     * Return a Promise that resolves when the busy state is off
     */
    async idle() {
        await this.state.ready('off');
    }
    /**
     * @deprecated use idle() instead
     */
    async available() {
        console.error('available() is deprecated, use idle() instead.\n' + new Error().stack);
        return this.idle();
    }
}
export { BusyIndicator };
//# sourceMappingURL=busy-indicator.js.map