/// <reference types="node" />
/**
 * Licenst: Apache-2.0
 * https://github.com/huan/state-switch
 */
import { EventEmitter } from 'events';
import { Constructor } from 'clone-class';
import { Interpreter } from 'xstate';
import { StateSwitchOptions } from '../interface.js';
import { ServiceCtlContext, ServiceCtlEvent, ServiceCtlState } from './machine-config.js';
declare const serviceCtlFsmMixin: (serviceCtlName?: string, options?: StateSwitchOptions | undefined) => <SuperClass extends Constructor<{
    emit: Function;
}>>(superClass: SuperClass) => ((abstract new (...args: any[]) => {
    _serviceCtlLog: any;
    _serviceCtlFsmInterpreter: Interpreter<ServiceCtlContext, ServiceCtlState, ServiceCtlEvent>;
    start(): Promise<void>;
    stop(): Promise<void>;
    reset(): Promise<void>;
    onStart(): Promise<void>;
    onStop(): Promise<void>;
    emit: Function;
}) & {
    VERSION: string;
}) & SuperClass;
declare const ServiceCtlFsm_base: ((abstract new (...args: any[]) => {
    _serviceCtlLog: any;
    _serviceCtlFsmInterpreter: Interpreter<{
        counter: number;
    }, ServiceCtlState, ServiceCtlEvent, {
        value: any;
        context: {
            counter: number;
        };
    }>;
    start(): Promise<void>;
    stop(): Promise<void>;
    reset(): Promise<void>;
    onStart(): Promise<void>;
    onStop(): Promise<void>;
    emit: Function;
}) & {
    VERSION: string;
}) & typeof EventEmitter;
declare abstract class ServiceCtlFsm extends ServiceCtlFsm_base {
}
export { ServiceCtlFsm, serviceCtlFsmMixin, };
